-- name: Hangout - Bitforts
-- description: This mod adds a custom Super Mario Bros. themed map to your server! This map is completely isolated from the game itself, which allows it to co-exist alongside whatever you're running!\nThis mod gives a basic way to enter the map through a simple command (/retrowarp), but feel free to modify it to make your own way to it!\n\nMap by chillyzone\nSpecial thanks to flipflopbell for their 3D Skybox Template :)

-- register the level here
LEVEL_HANGOUT_RETRO = 101
level_register('level_hangout_retro_entry', COURSE_NONE, 'Bitforts', 'hangout_retro', 28000, 0x08, 0x08, 0x08)
local level_hangout_retro = smlua_level_util_get_info_from_short_name('hangout_retro')
level_hangout_retro.levelNum = LEVEL_HANGOUT_RETRO

----------------------------
--     Skybox       ---
----------------------------
E_MODEL_RETROSKY = smlua_model_util_get_id("retro_skybox")

-- Behavior
local l = gLakituState

function bhv_skybox_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.header.gfx.skipInViewCheck = true
    obj_scale(o, 10.0)
end

function bhv_skybox_loop(o)
    o.oPosX = l.pos.x
    o.oPosY = l.pos.y
    o.oPosZ = l.pos.z
end

id_bhv3DSkybox = hook_behavior(bhv3DSkybox, OBJ_LIST_LEVEL, false, bhv_skybox_init, bhv_skybox_loop)

function retroinit()
    local skyboxcheck = obj_get_nearest_object_with_behavior_id(o, id_bhv3DSkybox)
    local p = gNetworkPlayers[0]
    if p.currLevelNum == LEVEL_HANGOUT_RETRO then
        area_get_warp_node(0x00).node.destLevel = gLevelValues.entryLevel
    end
    if skyboxcheck == nil and p.currLevelNum == LEVEL_HANGOUT_RETRO then
        spawn_non_sync_object(id_bhv3DSkybox, E_MODEL_RETROSKY, l.pos.x, l.pos.y, l.pos.z, nil)
    end
end

function retro_warp()
    if gNetworkPlayers[0] then
        warp_to_level(LEVEL_HANGOUT_RETRO, 1, 0)
        return true
    end
end

hook_event(HOOK_ON_LEVEL_INIT, retroinit)
hook_chat_command("retrowarp", "Warps you to Bitforts.", retro_warp)